package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility<T> {

    private T[] element;

    public ArrayUtility( T[] array){

        this.element = array;
    }

    public T[] merge(T[] arrayToMerge){
        T[] merged = Stream.concat(Arrays.stream(arrayToMerge), Arrays.stream(element))
                .toArray(size -> (T[]) Array.newInstance(element.getClass().getComponentType(), element.length + arrayToMerge.length));
        return merged;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        Integer count = 0;
        for (T element: merge(arrayToMerge)){
            if(element.equals(valueToEvaluate)){
                count++;
            }
        }
        return count;
    }

    public T[] removeValue(T valueToRemove) {
//        ArrayList<T> arr = new ArrayList<>();
//        for (T e: element){
//            if (!e.equals(valueToRemove)){
//                arr.add(e);
//            }
//        }
//        return arr.toArray((T[]) Array.newInstance(element.getClass().getComponentType(), arr.size()));
        int j = 0;
        for (int i = 0; i < element.length; i++){
            if (!(element[i].equals(valueToRemove))){
                element[j] = element[i];
                j++;
            }
        }
        return Arrays.copyOf(element, j);
    }



    public T getMostCommonFromMerge(T[] arrayToMerge) {
        T[] merged = merge(arrayToMerge);
        T thing = null;
        int mostOcc = 0;
        int count = 0;
        for (int i = 0; i < merged.length; i++){
            for (int j = 0; j < merged.length; j++){
                if(merged[i].equals(merged[j])){
                    count++;
                }
            }
            if (count > mostOcc){
                thing = merged[i];
                mostOcc = count;
            }
            count = 0;
        }
        return thing;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;
        for (int i = 0; i < element.length; i++){
            if(element[i].equals(valueToEvaluate)) {
                count++;
            }
        }
        return count;
    }
}
